#include "TauolaEvent.h"
#include "Plots.h"

using namespace std;

void TauolaEvent::undecayTaus(){
  
  std::vector<TauolaParticle*> particle_list;
  particle_list = findParticles(Tauola::getDecayingParticle());

  for(int p=0; p < (int) particle_list.size(); p++)
    particle_list.at(p)->findLastSelf()->undecay();

}

void TauolaEvent::decayTaus(){

  std::vector<TauolaParticle*> particle_list;
  particle_list = findStableParticles(Tauola::getDecayingParticle());

  while(particle_list.size()!=0){
    TauolaParticle * tau_particle = particle_list.back();
    particle_list.pop_back();

    TauolaParticlePair t_pair(tau_particle);

    Plots::SANC(t_pair);

    //erase the matching tau from the list
    for(int i=0; i<(int)particle_list.size();i++){
      if(t_pair.contains(particle_list.at(i)))
	particle_list.erase(particle_list.begin()+i);
    }
    //    t_pair.print();
    t_pair.decayTauPair();
    t_pair.checkMomentumConservation();
  }
  eventEndgame();
  return;

}
